searchNodes=[{"ref":"JSONHyperschema.ClientBuilder.html","title":"JSONHyperschema.ClientBuilder","type":"module","doc":"This module provides a series of macros that transform a JSON hyperschema into set of client modules."},{"ref":"JSONHyperschema.ClientBuilder.html#defaction/6","title":"JSONHyperschema.ClientBuilder.defaction/6","type":"macro","doc":"Builds a function based on the needs of the schema. JSON pointers inside hrefs become function parameters. For example: &quot;href&quot;: &quot;/things/{(%23%2Fdefinitions%2Fthing%2Fdefinitions%2Fidentity)}&quot; contains the JSON pointer #/definitions/thing/definitions/identity which is resolved to the &#39;thing&#39; attribute &#39;id&#39;, so the function becomes: Foo.Bar.get(id, ...) if the action has a schema, the last function parameter is params. And when the function is called the params are checked against the action&#39;s schema. if its the type of method that has a body, the params are JSON encoded and sent as the body, otherwise they are added as URL query parameters."},{"ref":"JSONHyperschema.ClientBuilder.html#defapi/3","title":"JSONHyperschema.ClientBuilder.defapi/3","type":"macro","doc":"Defines an API client based on a JSON hyperschema. This macro defines submodules for each defined type (via defresource). Example defmodule Foo.Client do schema_json = File.read!(schema_path) defapi __MODULE__, :my_app, schema_json end will create a submodule under Foo.Client for each type definition in the schema, and a function for each API call described by &quot;links&quot;. If the schema contains the following: ... &quot;definitions&quot;: { &quot;bar&quot;: { &quot;links&quot;: [ { &quot;title&quot;: &quot;Info&quot;, &quot;rel&quot;: &quot;self&quot;, &quot;description&quot;: &quot;Information about a bar&quot;, &quot;href&quot;: &quot;/bars/{(%23%2Fdefinitions%2Fbar%2Fdefinitions%2Fidentity)}&quot;, &quot;method&quot;: &quot;GET&quot;, ... } ] } } ... The function get/1 in the module Foo.Client.Bar will be defined. The function&#39;s parameter will be the value of the identity to be inserted in the URL."},{"ref":"JSONHyperschema.ClientBuilder.html#defresource/3","title":"JSONHyperschema.ClientBuilder.defresource/3","type":"macro","doc":"Defines a module for a type (found in a JSON hyperschema definition) and defines a function for each of the type&#39;s links (via defaction)."},{"ref":"JSONHyperschema.ClientBuilder.MissingDefinitionsError.html","title":"JSONHyperschema.ClientBuilder.MissingDefinitionsError","type":"exception","doc":""},{"ref":"JSONHyperschema.Schema.html","title":"JSONHyperschema.Schema","type":"module","doc":""},{"ref":"JSONHyperschema.Schema.html#denormalize_fragment/2","title":"JSONHyperschema.Schema.denormalize_fragment/2","type":"function","doc":""},{"ref":"JSONHyperschema.Schema.html#endpoint/1","title":"JSONHyperschema.Schema.endpoint/1","type":"function","doc":""},{"ref":"JSONHyperschema.Schema.html#endpoint!/1","title":"JSONHyperschema.Schema.endpoint!/1","type":"function","doc":""},{"ref":"JSONHyperschema.Schema.html#raise_or_return_endpoint/1","title":"JSONHyperschema.Schema.raise_or_return_endpoint/1","type":"function","doc":""},{"ref":"JSONHyperschema.Schema.html#to_schema/1","title":"JSONHyperschema.Schema.to_schema/1","type":"function","doc":"Removes links from all definitions"},{"ref":"JSONHyperschema.Schema.MissingEndpointError.html","title":"JSONHyperschema.Schema.MissingEndpointError","type":"exception","doc":""},{"ref":"JSONPointer.html","title":"JSONPointer","type":"module","doc":""},{"ref":"JSONPointer.html#parse/2","title":"JSONPointer.parse/2","type":"function","doc":"Takes a URI, optionally containing JSON pointers, and an ExJsonSchema resolved schema and returns a 2-element tuple containing a path template, and the variables to insert in the template. parse( &quot;/foo/{(%23%2Fdefinitions%2Fthing%2Fdefinitions%2Fweight)}/bar&quot;, schema ) {&quot;/foo/\#{bar}&quot;, [:bar]}"}]